import java.util.*;
public class LinkedList implements Enumeration
{
  private LinkedElement first;
  private LinkedElement last;
  private LinkedElement next;

  public void addFirst(String inData)
  {
    LinkedElement temp = new LinkedElement(inData);
    if(first == null)
    {
      first = temp;
      last = temp;
      next = temp;
      temp.setNext(temp);
      temp.setPrev(temp);
    }
    else
    {
      temp.setNext(first);
      temp.setPrev(last);
      last.setNext(temp);
      first.setPrev(temp);
      first = temp;
    }
  }

  public void addLast(String inData)
  {
    LinkedElement temp = new LinkedElement(inData);
    if(first == null)
    {
      first = temp;
      last = temp;
      next = temp;
      temp.setNext(temp);
      temp.setPrev(temp);
    }
    else
    {
      temp.setNext(first);
      temp.setPrev(last);
      last.setNext(temp);
      first.setPrev(temp);
      last = temp;
    }
  }

  public int length()
  {
    LinkedElement p = first;
    int l = 0;
    if(first == null)
      return 0;
    if(first == last)
      return 1;
    while(true)
    {
      l++;
      if(p.getNext() == first)
        break;
      p = p.getNext();
    }
    return l;
  }
  public boolean isEmty()
  {
    if(first == null)
      return false;
    else
      return true;
  }

  public boolean isMember(String equalTo)
  {
    LinkedElement p = first;
    if(first == null)
      return false;
    else
    {
      while(true)
      {
        if(p.getData() == equalTo)
          return true;
        if(p.getNext() == first)
          break;
        p = p.getNext();
      }
      return false;
    }
  }

  public void delString(String delString)
  {
    LinkedElement p = first;
    if(first == null)
      return;
    else
    {
      while(true)
      {
        if(p.getData().equals(delString))
        {
          p.getPrev().setNext(p.getNext());
          p.getNext().setPrev(p.getPrev());
          if(p == first)
            first = p.getNext();
          if(p == last)
            last = p.getPrev();
          next = p.getNext();
          break;
        }
        if(p.getNext() == first)
          break;
        p = p.getNext();
      }
    }
  }

  public String findAt(int pos)
  {
    LinkedElement p = first;
    int nr = 0;
    if(first == null)
      return "";
    else
    {
      while(true)
      {
        nr++;
        if(pos == nr)
        {
          return p.getData();
        }
        if(p.getNext() == first)
          break;
        p = p.getNext();
      }
      return "";
    }
  }

  public void changeAt(int pos, String inData)
  {
    LinkedElement p = first;
    int nr = 0;
    if(first == null)
      return;
    else
    {
      while(true)
      {
        nr++;
        if(pos == nr)
        {
          p.setData(inData);
          break;
        }
        if(p.getNext() == first)
          break;
        p = p.getNext();
      }
    }
  }

  public void printAll()
  {
    LinkedElement p = first;
    if(first == null)
      return;
    else
    {
      while(true)
      {
        System.out.println(p.getData());
        if(p.getNext() == first)
          break;
        p = p.getNext();
      }
    }
  }

  public Enumeration elements()
  {
    return this;
  }

  public Object nextElement()
  {
    next = next.getNext();
    return next.getPrev().getData();
  }

  public boolean hasMoreElements()
  {
    if(next.getNext() == first)
      return false;
    else
      return true;
  }
}